;######################################################################## 
;######################################################################## 
;######################################################################## 
BERECHNUNG_HOEHE:
	; GPS-HHEN-ANGABE-LADEN	
	LDS temp1,(adr_GPS_HOEHE_L)				; in SRAM speichern
	LDS temp2,(adr_GPS_HOEHE_H)				; in SRAM speichern
	; OFFSET-WERT laden			
	LDS temp3,(adr_GPS_HOEHE_OFFSET_L)
	LDS temp4,(adr_GPS_HOEHE_OFFSET_H)	
	; HHENDIFFERENZ ermitteln			
	sub temp1,temp3
	sbc temp2,temp4 
	; BERECHNETE-HHEN-ANGABE-SPEICHERN	
	STS(adr_GPS_HOEHE_BERECHNET_L),temp1	; in SRAM speichern 
	STS(adr_GPS_HOEHE_BERECHNET_H),temp2	; in SRAM speichern	

ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
BERECHNUNG_ONLINE_OFFLINE:
	LDS temp1,(adr_GPS_hh)				; aus SRAM holen	
	LDS temp2,(adr_GPS_mm)
	LDS temp3,(adr_GPS_ss)

	LDS temp,(adr_GPS_AKTIV)			; aus SRAM holen	
	cpi temp, 'A'
	breq BERECHNUNG_ONLINE_OFFLINE_ON
	STS (adr_GPS_ONLINE_hh),temp1		; in SRAM speichern	
	STS (adr_GPS_ONLINE_mm),temp2
	STS (adr_GPS_ONLINE_ss),temp3
	ret
BERECHNUNG_ONLINE_OFFLINE_ON:
	STS (adr_GPS_OFFLINE_hh),temp1		; in SRAM speichern	
	STS (adr_GPS_OFFLINE_mm),temp2
	STS (adr_GPS_OFFLINE_ss),temp3
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
BERECHNUNG_PEGEL:
	clr temp1
	clr temp2
	clr temp4
	clr temp5
	; initialisieren ZEIGER			
	ldi XL,low (adr_GPS_PEGEL_1_1)
	ldi XH,high(adr_GPS_PEGEL_1_1)

	; SCHLEIFE initialisieren		
	ldi temp,11
BERECHNUNG_PEGEL_w:
	LD temp3, X+											; laden und X+1		
	rcall BERECHNUNG_PEGEL_ADDIEREN
	dec temp
	brne BERECHNUNG_PEGEL_w

	; SUMME aller PEGELWERTE		
	STS(adr_GPS_PEGEL_SUMME_L),temp1	; in SRAM speichern
	STS(adr_GPS_PEGEL_SUMME_H),temp2

	STS (adr_GPS_PEGEL_ANZAHL),temp5	; in SRAM speichern		

	ret
;------------------------
BERECHNUNG_PEGEL_ADDIEREN:
	; addieren		
	add temp1,temp3
	adc temp2,temp4
	; ist PEGEL > 0 
	tst temp3
	brne BERECHNUNG_PEGEL_ADDIEREN_w
	ret
BERECHNUNG_PEGEL_ADDIEREN_w:
	; +1			
	inc temp5
ret
;############################################################################
;############################################################################
;############################################################################
GPS_BERECHNUNG_ENTFERNUNG:

;	cbi PORTD, LED_D_BLAU	; BLAU an	

	; Maeinheit auf m (Meter) umschalten	
	clr temp
	STS(adr_GPS_ENTFERNUNG_in_km),temp			; 0=Meter 1=km		
;############################################################################
	; GPS-LNGE LADEN					
	LDS temp1,(adr_GPS_X_LAENGE_BYTE1)			; aus SRAM laden	
	LDS temp2,(adr_GPS_X_LAENGE_BYTE2)			; aus SRAM laden	
	LDS temp3,(adr_GPS_X_LAENGE_BYTE3)			; aus SRAM laden	
	LDS temp4,(adr_GPS_X_LAENGE_BYTE4)			; aus SRAM laden	
	; REFERENZ_LNGE laden				
	LDS temp5,(adr_GPS_REFERENZ_X_LAENGE_BYTE1)	; aus SRAM laden	
	LDS temp6,(adr_GPS_REFERENZ_X_LAENGE_BYTE2)	; aus SRAM laden	
	LDS temp7,(adr_GPS_REFERENZ_X_LAENGE_BYTE3)	; aus SRAM laden	
	LDS temp8,(adr_GPS_REFERENZ_X_LAENGE_BYTE4)	; aus SRAM laden	
	; DIFFERENZ berechnen	(Bsp: 11.020.923-10.816.423=204.500)
	sub temp1,temp5
	sbc temp2,temp6
	sbc temp3,temp7
	sbc temp4,temp8
	; BETRAG BILDEN							
	rcall FUNKTION_BETRAG_BILDEN_32 	; INP:TEMP1...4 OUT: TEMP1...4 
	; durch 10 (Bsp: 204.500 / 10 = 20.450)	
	rcall FUNKTION_DIVISION_DURCH_10_32 ; INP:TEMP1...4 OUT: TEMP1...4 
	; X ZWISCHENERGEBNIS speichern			
	STS(adr_X_LAENGE_DIFFERENZ_BYTE1),temp1		; in SRAM speichern	
	STS(adr_X_LAENGE_DIFFERENZ_BYTE2),temp2		; in SRAM speichern	
	STS(adr_X_LAENGE_DIFFERENZ_BYTE3),temp3		; in SRAM speichern	
	STS(adr_X_LAENGE_DIFFERENZ_BYTE4),temp4		; in SRAM speichern	

;############################################################################
	; GPS-BREITE LADEN					
	LDS temp1,(adr_GPS_Y_BREITE_BYTE1)			; aus SRAM laden	
	LDS temp2,(adr_GPS_Y_BREITE_BYTE2)			; aus SRAM laden	
	LDS temp3,(adr_GPS_Y_BREITE_BYTE3)			; aus SRAM laden	
	LDS temp4,(adr_GPS_Y_BREITE_BYTE4)			; aus SRAM laden	
	; REFERENZ-BREITE laden				
	LDS temp5,(adr_GPS_REFERENZ_Y_BREITE_BYTE1)	; aus SRAM laden	
	LDS temp6,(adr_GPS_REFERENZ_Y_BREITE_BYTE2)	; aus SRAM laden	
	LDS temp7,(adr_GPS_REFERENZ_Y_BREITE_BYTE3)	; aus SRAM laden	
	LDS temp8,(adr_GPS_REFERENZ_Y_BREITE_BYTE4)	; aus SRAM laden	
	; DIFFERENZ berechnen	(Bsp: 50987526-50869762=117.764)
	sub temp1,temp5
	sbc temp2,temp6
	sbc temp3,temp7
	sbc temp4,temp8
	; BETRAG BILDEN						
	rcall FUNKTION_BETRAG_BILDEN_32 	; INP:TEMP1...4 OUT: TEMP1...4 
	;durch 10 (Bsp: 117.764 / 10= 11.776)
	rcall FUNKTION_DIVISION_DURCH_10_32 ; INP:TEMP1...4 OUT: TEMP1...4 
	; ZWISCHENERGEBNIS speichern		
	STS(adr_Y_BREITE_DIFFERENZ_BYTE1),temp1		; in SRAM speichern	
	STS(adr_Y_BREITE_DIFFERENZ_BYTE2),temp2		; in SRAM speichern	
	STS(adr_Y_BREITE_DIFFERENZ_BYTE3),temp3		; in SRAM speichern	
	STS(adr_Y_BREITE_DIFFERENZ_BYTE4),temp4		; in SRAM speichern	
;############################################################################
	; UMSCHALTUNG auf km				
	rcall GPS_BERECHNUNG_ENTFERNUNG_AUF_KM_UMSCHALTEN
;############################################################################
	; mal FAKTOR-X (70km/GRD)	(Bsp: 20.450*70=1.435.000)
	LDS temp1,(adr_X_LAENGE_DIFFERENZ_BYTE1)	; aus SRAM laden	
	LDS temp2,(adr_X_LAENGE_DIFFERENZ_BYTE2)	; aus SRAM laden	
	ldi temp3, LOW(FAKTOR_X)
	ldi temp4,HIGH(FAKTOR_X)
	rcall FUNKTION_MULTIPLIKATION_16_16	; INPUT: TEMP1+2/TEMP3+4 OUTPUT: Temp1...4	
	;durch 100					(Bsp: 1.435.000 / 100 = 14.350)
	rcall FUNKTION_DIVISION_DURCH_100_32 ; INP: TEMP1...4 OUT: TEMP1...4 
	; DIFFERENZ speichern	  				
	STS(adr_X_LAENGE_DIFFERENZ_BYTE1),temp1		; in SRAM speichern	
	STS(adr_X_LAENGE_DIFFERENZ_BYTE2),temp2		; in SRAM speichern	
	STS(adr_X_LAENGE_DIFFERENZ_BYTE3),temp3		; in SRAM speichern	
	STS(adr_X_LAENGE_DIFFERENZ_BYTE4),temp4		; in SRAM speichern	

;############################################################################
	; mal FAKTOR-Y (111km/GRD)	(Bsp:11.776*111=1.307.136 )
	LDS temp1,(adr_Y_BREITE_DIFFERENZ_BYTE1)	; aus SRAM laden	
	LDS temp2,(adr_Y_BREITE_DIFFERENZ_BYTE2)	; aus SRAM laden		
	ldi temp3, LOW(FAKTOR_Y)
	ldi temp4,HIGH(FAKTOR_Y)
	rcall FUNKTION_MULTIPLIKATION_16_16	; INPUT: TEMP1+2/TEMP3+4 OUTPUT: Temp1...4	
	;durch 100					(Bsp:1.307.136 / 100= 13.071)
	rcall FUNKTION_DIVISION_DURCH_100_32 ; INP: TEMP1...4 OUT: TEMP1...4 
	; DIFFERENZ speichern	  
	STS(adr_Y_BREITE_DIFFERENZ_BYTE1),temp1		; in SRAM speichern	
	STS(adr_Y_BREITE_DIFFERENZ_BYTE2),temp2		; in SRAM speichern	
	STS(adr_Y_BREITE_DIFFERENZ_BYTE3),temp3		; in SRAM speichern	
	STS(adr_Y_BREITE_DIFFERENZ_BYTE4),temp4		; in SRAM speichern	
; #################################################################################
	; Y - BREITE Quadrieren	
	LDS temp1,(adr_Y_BREITE_DIFFERENZ_BYTE1)	; aus SRAM laden	
	LDS temp2,(adr_Y_BREITE_DIFFERENZ_BYTE2)	; aus SRAM laden	
	mov temp3,temp1
	mov temp4,temp2
	rcall FUNKTION_MULTIPLIKATION_16_16	; INPUT: TEMP1+2/TEMP3+4 OUTPUT: Temp1...4	
	; Y - BREITE Zwischenergebnis speichern
	STS(adr_GPS_ENTFERNUNG_BYTE_1),temp1		; in SRAM speichern	
	STS(adr_GPS_ENTFERNUNG_BYTE_2),temp2		; in SRAM speichern	
	STS(adr_GPS_ENTFERNUNG_BYTE_3),temp3		; in SRAM speichern	
	STS(adr_GPS_ENTFERNUNG_BYTE_4),temp4		; in SRAM speichern	
	; X - LNGE Quadrieren					
	LDS temp1,(adr_X_LAENGE_DIFFERENZ_BYTE1)	; aus SRAM laden	
	LDS temp2,(adr_X_LAENGE_DIFFERENZ_BYTE2)	; aus SRAM laden	
	mov temp3,temp1
	mov temp4,temp2
	rcall FUNKTION_MULTIPLIKATION_16_16			; INPUT: TEMP1+2/TEMP3+4 OUTPUT: Temp1...4		
	; Y - BREITE Zwischenergebnis laden		
	LDS temp5,(adr_GPS_ENTFERNUNG_BYTE_1)		; aus SRAM laden	
	LDS temp6,(adr_GPS_ENTFERNUNG_BYTE_2)		; aus SRAM laden	
	LDS temp7,(adr_GPS_ENTFERNUNG_BYTE_3)		; aus SRAM laden	
	LDS temp8,(adr_GPS_ENTFERNUNG_BYTE_4)		; aus SRAM laden	
	;     X und Y    addieren				
	add temp1,temp5
	adc temp2,temp6
	adc temp3,temp7
	adc temp4,temp8
	; WURZEL ziehen							
	rcall WURZEL_32								; INP: TEMP1...4 OUT: TEMP1...2
	clr temp3
	clr temp4
	; ENTFERNUNG speichern	
	STS(adr_GPS_ENTFERNUNG_BYTE_1),temp1		; in SRAM speichern	
	STS(adr_GPS_ENTFERNUNG_BYTE_2),temp2		; in SRAM speichern	
	STS(adr_GPS_ENTFERNUNG_BYTE_3),temp3		; in SRAM speichern	
	STS(adr_GPS_ENTFERNUNG_BYTE_4),temp4		; in SRAM speichern	

;	sbi PORTD, LED_D_BLAU	; BLAU aus	

ret
;###################################################################
;###################################################################
;###################################################################
GPS_BERECHNUNG_ENTFERNUNG_AUF_KM_UMSCHALTEN:
	; Prfung, ob jeweils Byte3+4 >0		
	LDS temp,(adr_X_LAENGE_DIFFERENZ_BYTE3)	; aus SRAM laden	
	tst temp
	brne GPS_BERECHNUNG_ENTFERNUNG_AUF_KM_UMSCHALTEN_START
	LDS temp,(adr_X_LAENGE_DIFFERENZ_BYTE4)	; aus SRAM laden	
	tst temp
	brne GPS_BERECHNUNG_ENTFERNUNG_AUF_KM_UMSCHALTEN_START
	LDS temp,(adr_Y_BREITE_DIFFERENZ_BYTE3)	; aus SRAM laden	
	tst temp
	brne GPS_BERECHNUNG_ENTFERNUNG_AUF_KM_UMSCHALTEN_START
	LDS temp,(adr_Y_BREITE_DIFFERENZ_BYTE4)	; aus SRAM laden	
	tst temp
	brne GPS_BERECHNUNG_ENTFERNUNG_AUF_KM_UMSCHALTEN_START
	ret
GPS_BERECHNUNG_ENTFERNUNG_AUF_KM_UMSCHALTEN_START:
	; X durch 1000	
	LDS temp1,(adr_X_LAENGE_DIFFERENZ_BYTE1)	; aus SRAM laden	
	LDS temp2,(adr_X_LAENGE_DIFFERENZ_BYTE2)	; aus SRAM laden	
	LDS temp3,(adr_X_LAENGE_DIFFERENZ_BYTE3)	; aus SRAM laden	
	LDS temp4,(adr_X_LAENGE_DIFFERENZ_BYTE4)	; aus SRAM laden	
	rcall FUNKTION_DIVISION_DURCH_1000_32 ; INP: TEMP1...4 OUT: TEMP1...4 	
	STS(adr_X_LAENGE_DIFFERENZ_BYTE1),temp1		; in SRAM speichern	
	STS(adr_X_LAENGE_DIFFERENZ_BYTE2),temp2		; in SRAM speichern	
	STS(adr_X_LAENGE_DIFFERENZ_BYTE3),temp3		; in SRAM speichern	
	STS(adr_X_LAENGE_DIFFERENZ_BYTE4),temp4		; in SRAM speichern	


	; Y durch 1000	
	LDS temp1,(adr_Y_BREITE_DIFFERENZ_BYTE1)	; aus SRAM laden	
	LDS temp2,(adr_Y_BREITE_DIFFERENZ_BYTE2)	; aus SRAM laden	
	LDS temp3,(adr_Y_BREITE_DIFFERENZ_BYTE3)	; aus SRAM laden	
	LDS temp4,(adr_Y_BREITE_DIFFERENZ_BYTE4)	; aus SRAM laden	
	rcall FUNKTION_DIVISION_DURCH_1000_32 ; INP: TEMP1...4 OUT: TEMP1...4 	
	STS(adr_Y_BREITE_DIFFERENZ_BYTE1),temp1		; in SRAM speichern	
	STS(adr_Y_BREITE_DIFFERENZ_BYTE2),temp2		; in SRAM speichern	
	STS(adr_Y_BREITE_DIFFERENZ_BYTE3),temp3		; in SRAM speichern	
	STS(adr_Y_BREITE_DIFFERENZ_BYTE4),temp4		; in SRAM speichern	

	; Maeinheit auf km  umschalten	
	ldi temp,1
	STS(adr_GPS_ENTFERNUNG_in_km),temp			; 0=Meter 1=km		


ret
;###################################################################
;###################################################################
;###################################################################
