;#######################################################################
;#######################################################################
;#######################################################################
GPS_CLEAR_START:
; SRAM GPS_DATEN_BEREICH lschen								
	ldi XL, LOW (adr_GPS_DATEN_BEREICH_BEGINN)
	ldi XH, HIGH(adr_GPS_DATEN_BEREICH_BEGINN)
	clr temp	
	ldi temp1,255
GPS_CLEAR_START_w:
	ST X+,temp
	dec temp1
	brne GPS_CLEAR_START_w	

; GPS-STRING komplett =0				
	clr temp
	STS (adr_GPS_DATEN_STRING_KOMPLETT),temp	; in SRAM schreiben				

; ANZAHL ZEICHEN lschen				
	clr temp
	STS(adr_GPS_DATEN_ZEICHEN_ANZAHL),temp		; in SRAM schreiben	
; SCHREIB-POSITION auf ANFANG setzen	
	ldi temp1, low(adr_GPS_DATEN_BEREICH_BEGINN)
	ldi temp2,high(adr_GPS_DATEN_BEREICH_BEGINN)
	STS(adr_GPS_DATEN_SCHREIB_POSITION_L),temp1	; in SRAM schreiben	
	STS(adr_GPS_DATEN_SCHREIB_POSITION_H),temp2	; in SRAM schreiben	

 
ret
;#######################################################################
;#######################################################################
;#######################################################################
; Interruptroutine: wird ausgefhrt sobald ein Byte ber das UART empfangen wurde
ZEICHEN_EINLESEN:
		
		push temp           ; temp auf dem Stack sichern            
		in TEMP,SREG		; Einlesen des SREG 
		push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
		push temp1
		push temp2
		push temp3
		push temp4
		push temp5
		push temp6
		push temp7
		push temp8
		push temp9
		push ZL
		push ZH
		push XL
		push XH
		push GPS_EMPFANGSZEICHEN
;-------
	
		; GPS STRING einlesen				
		rcall GPS_STRING_EINLESEN
		; IST GPS-STRING komplett ?			
		LDS temp,(adr_GPS_DATEN_STRING_KOMPLETT)			; adr_GPS_DATEN_STRING_KOMPLETT=1		
		tst temp
		breq ZEICHEN_EINLESEN_FERTIG
		; AUSWERTUNG der einzelnen STRINGS	
		rcall GPRMC_AUSWERTEN
		rcall GPGGA_AUSWERTEN
		rcall GPGSV_X_1
		rcall GPGSV_X_2
		rcall GPGSV_X_3
		; STRING clear 						
		rcall GPS_CLEAR_START
ZEICHEN_EINLESEN_FERTIG:
;-------
		pop GPS_EMPFANGSZEICHEN
		pop XH
		pop XL
		pop ZH
		pop ZL
		pop temp9
		pop temp8
		pop temp7
		pop temp6
		pop temp5
		pop temp4
		pop temp3
		pop temp2
		pop temp1
		pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
		out	SREG,TEMP		; Wiederherstellen von SREG       
		pop temp      		; temp wiederherstellen                    
reti                              
;############################################################################
;############################################################################
;############################################################################
; Einen STRING einlesen. Er beginnt mit einem "$" und endet mit chr(10)		
; maximal 255 ZEICHEN														
; $GP...chr(13) chr(10)		
GPS_STRING_EINLESEN:
	; einlesen									
	in GPS_EMPFANGSZEICHEN, UDR	
	; aktuelle Anzahl der eingelesenen Zeichen	
	LDS temp,(adr_GPS_DATEN_ZEICHEN_ANZAHL) 	; aus SRAM einlesen	
	inc temp									; +1				
	STS (adr_GPS_DATEN_ZEICHEN_ANZAHL),temp		; in SRAM ablegen	
; GPS-EMPFANGS-ZEICHEN an neuer SCHREIBPOSITION schreiben	
	LDS XL,(adr_GPS_DATEN_SCHREIB_POSITION_L)			; aus SRAM laden	
	LDS XH,(adr_GPS_DATEN_SCHREIB_POSITION_H)			; aus SRAM laden	
	ST  X+, GPS_EMPFANGSZEICHEN							; schreiben und x+1	
; neue SCHREIBPOSITION schreiben							
	STS (adr_GPS_DATEN_SCHREIB_POSITION_L),XL			; in SRAM speichern	
	STS (adr_GPS_DATEN_SCHREIB_POSITION_H),XH			; in SRAM speichern	
	; Fehlerprfung 1.Zeichen "$"				
	cpi temp,1
	brne GPS_STRING_EINLESEN_2
	ldi temp, '$'		
	cp GPS_EMPFANGSZEICHEN,temp							; vergleich			
	brne GPS_STRING_EINLESEN_FEHLER						; ungleich ==> FEHLER
	ret
	; Fehlerprfung 2.Zeichen "G"				
GPS_STRING_EINLESEN_2:
	cpi temp,2
	brne GPS_STRING_EINLESEN_3
	ldi temp, 'G'		
	cp GPS_EMPFANGSZEICHEN,temp							; vergleich			
	brne GPS_STRING_EINLESEN_FEHLER						; ungleich ==> FEHLER
	ret
	; Fehlerprfung 3.Zeichen "P"				
GPS_STRING_EINLESEN_3:
	cpi temp,3
	brne GPS_STRING_EINLESEN_255
	ldi temp, 'P'		
	cp GPS_EMPFANGSZEICHEN,temp							; vergleich			
	brne GPS_STRING_EINLESEN_FEHLER						; ungleich ==> FEHLER
	ret
	; Fehlerprfung bei 255 Zeichen ==>Fehler
GPS_STRING_EINLESEN_255:
	LDS temp1,(adr_GPS_DATEN_ZEICHEN_ANZAHL) 			; aus SRAM einlesen	
	cpi temp1,255										; vergleich			 
	brne GPS_STRING_EINLESEN_ENDE
	breq GPS_STRING_EINLESEN_FEHLER
	; ENDE des GPS-STRINGS ermitteln chr(10)
GPS_STRING_EINLESEN_ENDE:
	ldi temp, 10
	cp GPS_EMPFANGSZEICHEN,temp							; vergleich			 
	breq GPS_STRING_EINLESEN_KOMPLETT
	ret
	; STRING wurde komplett eingelesen	
GPS_STRING_EINLESEN_KOMPLETT:
	ldi temp,1
	STS (adr_GPS_DATEN_STRING_KOMPLETT),temp			; adr_GPS_DATEN_STRING_KOMPLETT=1

	ret		
; ----------------------------------------------
GPS_STRING_EINLESEN_FEHLER:
	rcall GPS_CLEAR_START

ret
;############################################################################
;############################################################################
;############################################################################
; Feld 0       1    2     3     4      5     6  7      8     9    10      	 
; $GPRMC,082831.253,A,5059.2611,N,01101.2502,E,0.15,344.17,040706,,*0A		 
; 		ZEIT       A/V   NB           L       SOG   KURS  DATUM             
GPRMC_AUSWERTEN:
	; X ZEIGER auf STRING-ANFANG + 3
	ldi XL,low (adr_GPS_DATEN_BEREICH_BEGINN+3)			; aus SRAM laden	
	ldi XH,high(adr_GPS_DATEN_BEREICH_BEGINN+3)			; aus SRAM laden	
	; Fehlerprfung Zeichen Nr3 = "R"
	LD temp, X+											; laden und X+1		
	cpi temp, 'R'
	breq GPRMC_AUSWERTEN_START
	ret
;---------------------------------------
GPRMC_AUSWERTEN_START:
	; GPRMC KOPIE anlegen			
	; X ZEIGER initialisieren		
	ldi XL,low (adr_GPS_DATEN_BEREICH_BEGINN)			; aus SRAM laden	
	ldi XH,high(adr_GPS_DATEN_BEREICH_BEGINN)			; aus SRAM laden	
	; Z ZEIGER initialisieren		
	ldi ZL,low (adr_GPS_GPRMC_KOPIE_BEGINN)			; aus SRAM laden	
	ldi ZH,high(adr_GPS_GPRMC_KOPIE_BEGINN)			; aus SRAM laden	
	; SCHLEIFE initialisieren		
	ldi temp,100
GPRMC_AUSWERTEN_KOPIE_w:
	; KOPIERVORGANG					
	LD temp1, X+									; laden 	und X+1		
	ST Z+,temp1										; schreiben und Z+1		
	dec temp
	brne GPRMC_AUSWERTEN_KOPIE_w

; FELD 1 (ZEIT)							
	ldi temp1,1
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 		; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_HEX_ASC_CLEAR_32  			; OUT TEMP1...9 (alle auf "0")			
	LD temp2,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp1,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	rcall FUNKTION_ASC_HEX_32 					; INP: TEMP1...9 / OUT: TEMP1...4				
	STS (adr_GPS_hh),temp1						; in SRAM schreiben						
	;
	rcall FUNKTION_HEX_ASC_CLEAR_32  			; OUT TEMP1...9 (alle auf "0")			
	LD temp2,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp1,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	rcall FUNKTION_ASC_HEX_32 					; INP: TEMP1...9 / OUT: TEMP1...4				
	STS (adr_GPS_mm),temp1						; in SRAM schreiben						
	;
	rcall FUNKTION_HEX_ASC_CLEAR_32  			; OUT TEMP1...9 (alle auf "0")			
	LD temp2,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp1,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	rcall FUNKTION_ASC_HEX_32 					; INP: TEMP1...9 / OUT: TEMP1...4				
	STS (adr_GPS_ss),temp1						; in SRAM schreiben						
; FELD 2 (GPS-AKTIV) A/V				
	ldi temp1,2
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 		; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	LD temp,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	STS (adr_GPS_AKTIV),temp					; in SRAM schreiben				
GPRMC_AUSWERTEN_A_V_FERIG:
; FELD 7 (SOG_GESCHWINDIGKEIT) "12.34" kn 
	ldi temp1,7
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 	; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	;mal 1852 (1 kn = 1,852 km/h)	
	
	LDS temp,(adr_UNIT)
	cpi temp,0
	brne Weiter_mit_Knoten
	
	ldi temp3, low(FAKTOR_KNOTEN)
	ldi temp4,high(FAKTOR_KNOTEN)
	rcall FUNKTION_MULTIPLIKATION_16_16	; INP: TEMP1...2 / TEMP3...4 OUT: TEMP1...4 	
	; durch 100.000				 	
	ldi temp5,BYTE1(10000)
	ldi temp6,BYTE2(10000)
	ldi temp7,BYTE3(10000)
	clr temp8
	rcall DIVISION_32_32				; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4
Weiter_mit_Knoten:
	STS(adr_GPS_GESCHWINDIGKEIT_L),temp1
	STS(adr_GPS_GESCHWINDIGKEIT_H),temp2
; FELD 8 (KURS)
	ldi temp1,8
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 	; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	; durch 100 teilen	
	clr temp3
	clr temp4
	ldi temp5, low(10)
	ldi temp6,HIGH(10)
	clr temp7
	clr temp8
	rcall DIVISION_32_32	; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4
	STS(adr_GPS_KURS_L),temp1
	STS(adr_GPS_KURS_H),temp2

;----------------------------------------------	
;	ldi temp1,5
;	rcall FUNKTION_GPS_DATENFELD_SUCHEN 	; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
;	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	; durch 100 teilen	
;	clr temp3
;	clr temp4
;	ldi temp5, low(10)
;	ldi temp6,HIGH(10)
;	clr temp7
;	clr temp8
;	rcall DIVISION_32_32	; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4
;	STS(adr_QTH_LON),temp1

;	ldi temp1,3
;	rcall FUNKTION_GPS_DATENFELD_SUCHEN 	; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
;	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	; durch 100 teilen	
;	clr temp3
;	clr temp4
;	ldi temp5, low(10)
;	ldi temp6,HIGH(10)
;	clr temp7
;	clr temp8
;	rcall DIVISION_32_32	; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4
;	STS(adr_QTH_LAT),temp1
;------------------------------------------------

; FELD 9 (DATUM)
	ldi temp1,9
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 		; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_HEX_ASC_CLEAR_32  			; OUT TEMP1...9 (alle auf "0")			
	LD temp2,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp1,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	rcall FUNKTION_ASC_HEX_32 					; INP: TEMP1...9 / OUT: TEMP1...4				
	STS (adr_GPS_TAG),temp1						; in SRAM schreiben						
	;
	rcall FUNKTION_HEX_ASC_CLEAR_32  			; OUT TEMP1...9 (alle auf "0")			
	LD temp2,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp1,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	rcall FUNKTION_ASC_HEX_32 					; INP: TEMP1...9 / OUT: TEMP1...4				
	STS (adr_GPS_MONAT),temp1					; in SRAM schreiben						
	;
	rcall FUNKTION_HEX_ASC_CLEAR_32  			; OUT TEMP1...9 (alle auf "0")			
	LD temp2,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	LD temp1,X+									; ZEICHEN einlesen und X-Zeiger erhhen							
	rcall FUNKTION_ASC_HEX_32 					; INP: TEMP1...9 / OUT: TEMP1...4				
	STS (adr_GPS_JAHR),temp1					; in SRAM schreiben						



;-------------------------------------------------------------------------------
; FELD 3 (Y==>NRDLICHE-BREITE)	; $GPRMC,082831.253,A,5059.2611,........
	; X-ZEIGER-INITIALISIEREN auf GRAD-WERT	
	ldi temp1,3
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 		; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	; GRAD-WERT einlesen 
	rcall FUNKTION_HEX_ASC_CLEAR_32  	; OUT TEMP1...9 (alle auf "0")			
	LD temp8,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp7,X+							; ZEICHEN einlesen und X-Zeiger erhhen
; FEHLERPRFUNG, sendet die GPS-MOUSE "0" dann werden keine Daten aktuallisiert	
	cpi temp7,'0'
	brne GPRMC_AUSWERTEN_POSITION_START
	cpi temp8,'0'
	brne GPRMC_AUSWERTEN_POSITION_START
	ret
	; GRAD-WERT einlesen weiter
GPRMC_AUSWERTEN_POSITION_START:
	rcall FUNKTION_ASC_HEX_32 			; INP: TEMP1...9 / OUT: TEMP1...4
	STS (adr_GPS_Y_BREITE_BYTE1),temp1	; in SRAM speichern	
	STS (adr_GPS_Y_BREITE_BYTE2),temp2	; in SRAM speichern	
	STS (adr_GPS_Y_BREITE_BYTE3),temp3	; in SRAM speichern	
	STS (adr_GPS_Y_BREITE_BYTE4),temp4	; in SRAM speichern	

	; MINUTEN-WERT einlesen und mal 100			
	rcall FUNKTION_HEX_ASC_CLEAR_32  	; OUT TEMP1...9 (alle auf "0")			
	LD temp8,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp7,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	adiw XL,1							; X-Zeiger erhhen "."				   
	LD temp6,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp5,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp4,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp3,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	rcall FUNKTION_ASC_HEX_32 			; INP: TEMP1...9 / OUT: TEMP1...4	   
	; MINUTEN-WERT durch 60						
	ldi temp5, BYTE1(60)
	ldi temp6, BYTE2(60)
	ldi temp7, BYTE3(60)
	ldi temp8, BYTE4(60)
	rcall DIVISION_32_32	; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4	
	; GRAD-WERT LADEN					
	LDS temp5,(adr_GPS_Y_BREITE_BYTE1)	; aus SRAM laden	
	LDS temp6,(adr_GPS_Y_BREITE_BYTE2)	; aus SRAM laden	
	LDS temp7,(adr_GPS_Y_BREITE_BYTE3)	; aus SRAM laden	
	LDS temp8,(adr_GPS_Y_BREITE_BYTE4)	; aus SRAM laden	
	; GRAD und MINUTEN WERT addieren	
	add temp1,temp5
	adc temp2,temp6
	adc temp3,temp7
	adc temp4,temp8
	; GRAD und MINUTEN WERT als DEZIMALWERT speichern		
	STS (adr_GPS_Y_BREITE_BYTE1),temp1	; in SRAM speichern	
	STS (adr_GPS_Y_BREITE_BYTE2),temp2	; in SRAM speichern	
	STS (adr_GPS_Y_BREITE_BYTE3),temp3	; in SRAM speichern	
	STS (adr_GPS_Y_BREITE_BYTE4),temp4	; in SRAM speichern	

;-------------------------------------------------------------------------------
; FELD 5 (X==>STLICHE-LNGE)	$GPRMC,082831.253,A,5059.2611,N,01101.2502,

	; X-ZEIGER-INITIALISIEREN auf GRAD-WERT	
	ldi temp1,5
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 		; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	; GRAD-WERT einlesen 		
	rcall FUNKTION_HEX_ASC_CLEAR_32  	; OUT TEMP1...9 (alle auf "0")			
	LD temp9,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp8,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp7,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	rcall FUNKTION_ASC_HEX_32 			; INP: TEMP1...9 / OUT: TEMP1...4
	STS (adr_GPS_X_LAENGE_BYTE1),temp1	; in SRAM speichern	
	STS (adr_GPS_X_LAENGE_BYTE2),temp2	; in SRAM speichern	
	STS (adr_GPS_X_LAENGE_BYTE3),temp3	; in SRAM speichern	
	STS (adr_GPS_X_LAENGE_BYTE4),temp4	; in SRAM speichern	

	; MINUTEN-WERT einlesen und mal 100			
	rcall FUNKTION_HEX_ASC_CLEAR_32  	; OUT TEMP1...9 (alle auf "0")			
	LD temp8,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp7,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	adiw XL,1							; X-Zeiger erhhen					   
	LD temp6,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp5,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp4,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	LD temp3,X+							; ZEICHEN einlesen und X-Zeiger erhhen
	rcall FUNKTION_ASC_HEX_32 			; INP: TEMP1...9 / OUT: TEMP1...4	   
	; MINUTEN-WERT durch 60						
	ldi temp5, BYTE1(60)
	ldi temp6, BYTE2(60)
	ldi temp7, BYTE3(60)
	ldi temp8, BYTE4(60)
	rcall DIVISION_32_32	; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4	
	; GRAD-WERT LADEN					
	LDS temp5,(adr_GPS_X_LAENGE_BYTE1)	; aus SRAM laden	
	LDS temp6,(adr_GPS_X_LAENGE_BYTE2)	; aus SRAM laden	
	LDS temp7,(adr_GPS_X_LAENGE_BYTE3)	; aus SRAM laden	
	LDS temp8,(adr_GPS_X_LAENGE_BYTE4)	; aus SRAM laden	
	; GRAD und MINUTEN WERT addieren	
	add temp1,temp5
	adc temp2,temp6
	adc temp3,temp7
	adc temp4,temp8
	; GRAD und MINUTEN WERT als DEZIMALWERT speichern		
	STS (adr_GPS_X_LAENGE_BYTE1),temp1	; in SRAM speichern	
	STS (adr_GPS_X_LAENGE_BYTE2),temp2	; in SRAM speichern	
	STS (adr_GPS_X_LAENGE_BYTE3),temp3	; in SRAM speichern	
	STS (adr_GPS_X_LAENGE_BYTE4),temp4	; in SRAM speichern	
ret
;############################################################################
;############################################################################
;############################################################################
; Feld 0       1        2     3      4     5 6  7   8     9  10              
; $GPGGA,082831.253,5059.2611,N,01101.2502,E,1,04,23.7,264.7,M,,,,0000*37    
;       ZEIT          NB           L         SAT Gen  HHE                  
GPGGA_AUSWERTEN:
	; X ZEIGER auf STRING-ANFANG + 3
	ldi XL,low (adr_GPS_DATEN_BEREICH_BEGINN+3)			; aus SRAM laden	
	ldi XH,high(adr_GPS_DATEN_BEREICH_BEGINN+3)			; aus SRAM laden	
	; Fehlerprfung Zeichen Nr3 = "G"
	LD temp, X+											; laden und X+1		
	cpi temp, 'G'
	breq GPGGA_AUSWERTEN_w
	ret
GPGGA_AUSWERTEN_w:
	; Fehlerprfung Zeichen Nr4 = "G"
	LD temp, X+											; laden und X+1		
	cpi temp, 'G'
	breq GPGGA_AUSWERTEN_ww
	ret
GPGGA_AUSWERTEN_ww:
	; Fehlerprfung Zeichen Nr5 = "A"
	LD temp, X+											; laden und X+1		
	cpi temp, 'A'
	breq GPGGA_AUSWERTEN_START
	ret
GPGGA_AUSWERTEN_START:
;-------------------------------------------------------------------------------
; FELD 7 (ANZAHL-SATELLITEN-empfangen)	
	ldi temp1,7
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 							; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	STS (adr_GPS_ANZ_SAT_EMPFANGEN),temp1


; FELD 9 (HHE)							
	ldi temp1,9
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 							; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	; durch 10 teilen	
	clr temp3
	clr temp4
	ldi temp5, low(10)
	ldi temp6,HIGH(10)
	clr temp7
	clr temp8
	rcall DIVISION_32_32											; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4
	; Fehlerprfung (bei Hhe=0 erfolgt keine Aktuallisierung)
	tst temp1
	brne GPGGA_AUSWERTEN_HOEHE_w
	tst temp2
	brne GPGGA_AUSWERTEN_HOEHE_w
	ret
GPGGA_AUSWERTEN_HOEHE_w:
	; GPS-HHEN-ANGABE-SPEICHERN		
	STS(adr_GPS_HOEHE_L),temp1				; in SRAM speichern
	STS(adr_GPS_HOEHE_H),temp2				; in SRAM speichern


ret
;############################################################################
;############################################################################
;############################################################################
; Feld 0 1 2 3  4  5  6   7  8  9  10  11 12 13 14  15 16 17 18  19          
; $GPGSV,3,1,10,23,80,159,35,24,66,273,32,20,62,088,35,13,48,218,*7C		 
;           SAT           P            P            P            P           
GPGSV_X_1:
	; X ZEIGER auf STRING-ANFANG + 3
	ldi XL,low (adr_GPS_DATEN_BEREICH_BEGINN+3)			; aus SRAM laden	
	ldi XH,high(adr_GPS_DATEN_BEREICH_BEGINN+3)			; aus SRAM laden	
	; Fehlerprfung Zeichen Nr3 = "G"
	LD temp, X+											; laden und X+1		
	cpi temp, 'G'
	breq GPGSV_X_1_w
	ret
GPGSV_X_1_w:
	; Fehlerprfung Zeichen Nr4 = "S"
	LD temp, X+											; laden und X+1		
	cpi temp, 'S'
	breq GPGSV_X_1_ww
	ret
GPGSV_X_1_ww:
	; Fehlerprfung Zeichen Nr5 = "V"
	LD temp, X+											; laden und X+1		
	cpi temp, 'V'
	breq GPGSV_X_1_www
	ret
GPGSV_X_1_www:
	; X ZEIGER auf STRING-ANFANG + 9
	ldi XL,low (adr_GPS_DATEN_BEREICH_BEGINN+9)			; aus SRAM laden	
	ldi XH,high(adr_GPS_DATEN_BEREICH_BEGINN+9)			; aus SRAM laden	
	; Fehlerprfung Zeichen Nr9 = "1"
	LD temp, X+											; laden und X+1		
	cpi temp, '1'
	breq GPGSV_X_1_START
	ret
GPGSV_X_1_START:
;-----------------------------------------------------------------------
; FELD 3 (ANZAHL-SATELLITEN-gesamt)	
	ldi temp1,3
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 							; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	STS (adr_GPS_ANZ_SAT_GESAMT),temp1								; in SRAM ablegen	

; FELD 7 (PEGEL)	
	ldi temp1,7
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 							; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	STS (adr_GPS_PEGEL_1_1),temp1									; in SRAM ablegen	
; FELD 11 (PEGEL)	
	ldi temp1,11
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 							; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	STS (adr_GPS_PEGEL_1_2),temp1									; in SRAM ablegen	
; FELD 15 (PEGEL)	
	ldi temp1,15
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 							; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	STS (adr_GPS_PEGEL_1_3),temp1									; in SRAM ablegen	
; FELD 19 (PEGEL)	
	ldi temp1,19
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 							; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	STS (adr_GPS_PEGEL_1_4),temp1									; in SRAM ablegen	



ret
;############################################################################
;############################################################################
;############################################################################
; Feld 0 1 2 3  4  5  6   7  8  9  10  11 12 13 14  15 16 17 18  19          
; $GPGSV,3,2,10,04,40,301,,25,28,051,31,17,22,241,,11,15,158,*79				
GPGSV_X_2:
	; X ZEIGER auf STRING-ANFANG + 3
	ldi XL,low (adr_GPS_DATEN_BEREICH_BEGINN+3)			; aus SRAM laden	
	ldi XH,high(adr_GPS_DATEN_BEREICH_BEGINN+3)			; aus SRAM laden	
	; Fehlerprfung Zeichen Nr3 = "G"
	LD temp, X+											; laden und X+1		
	cpi temp, 'G'
	breq GPGSV_X_2_w
	ret
GPGSV_X_2_w:
	; Fehlerprfung Zeichen Nr4 = "S"
	LD temp, X+											; laden und X+1		
	cpi temp, 'S'
	breq GPGSV_X_2_ww
	ret
GPGSV_X_2_ww:
	; Fehlerprfung Zeichen Nr5 = "V"
	LD temp, X+											; laden und X+1		
	cpi temp, 'V'
	breq GPGSV_X_2_www
	ret
GPGSV_X_2_www:
	; X ZEIGER auf STRING-ANFANG + 9
	ldi XL,low (adr_GPS_DATEN_BEREICH_BEGINN+9)			; aus SRAM laden	
	ldi XH,high(adr_GPS_DATEN_BEREICH_BEGINN+9)			; aus SRAM laden	
	; Fehlerprfung Zeichen Nr9 = "2"
	LD temp, X+											; laden und X+1		
	cpi temp, '2'
	breq GPGSV_X_2_START
	ret
GPGSV_X_2_START:
;-----------------------------------------------------------------------

; FELD 7 (PEGEL)	
	ldi temp1,7
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 							; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	STS (adr_GPS_PEGEL_2_1),temp1									; in SRAM ablegen	
; FELD 11 (PEGEL)	
	ldi temp1,11
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 							; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	STS (adr_GPS_PEGEL_2_2),temp1									; in SRAM ablegen	
; FELD 15 (PEGEL)	
	ldi temp1,15
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 							; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	STS (adr_GPS_PEGEL_2_3),temp1									; in SRAM ablegen	
; FELD 19 (PEGEL)	
	ldi temp1,19
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 							; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	STS (adr_GPS_PEGEL_2_4),temp1									; in SRAM ablegen	

	
ret
;############################################################################
;############################################################################
;############################################################################
; Feld 0 1 2 3  4  5  6   7  8  9  10  11 12 13 14  15 16 17 18  19          
; $GPGSV,3,3,10,01,12,050,,02,07,315,*7D										
GPGSV_X_3:
	; X ZEIGER auf STRING-ANFANG + 3
	ldi XL,low (adr_GPS_DATEN_BEREICH_BEGINN+3)			; aus SRAM laden	
	ldi XH,high(adr_GPS_DATEN_BEREICH_BEGINN+3)			; aus SRAM laden	
	; Fehlerprfung Zeichen Nr3 = "G"
	LD temp, X+											; laden und X+1		
	cpi temp, 'G'
	breq GPGSV_X_3_w
	ret
GPGSV_X_3_w:
	; Fehlerprfung Zeichen Nr4 = "S"
	LD temp, X+											; laden und X+1		
	cpi temp, 'S'
	breq GPGSV_X_3_ww
	ret
GPGSV_X_3_ww:
	; Fehlerprfung Zeichen Nr5 = "V"
	LD temp, X+											; laden und X+1		
	cpi temp, 'V'
	breq GPGSV_X_3_www
	ret
GPGSV_X_3_www:
	; X ZEIGER auf STRING-ANFANG + 9
	ldi XL,low (adr_GPS_DATEN_BEREICH_BEGINN+9)			; aus SRAM laden	
	ldi XH,high(adr_GPS_DATEN_BEREICH_BEGINN+9)			; aus SRAM laden	
	; Fehlerprfung Zeichen Nr9 = "3"
	LD temp, X+											; laden und X+1		
	cpi temp, '3'
	breq GPGSV_X_3_START
	ret
GPGSV_X_3_START:
;-----------------------------------------------------------------------


; FELD 7 (PEGEL)	
	ldi temp1,7
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 							; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	STS (adr_GPS_PEGEL_3_1),temp1									; in SRAM ablegen	
; FELD 11 (PEGEL)	
	ldi temp1,11
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 							; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	STS (adr_GPS_PEGEL_3_2),temp1									; in SRAM ablegen	
; FELD 15 (PEGEL)	
	ldi temp1,15
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 							; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	STS (adr_GPS_PEGEL_3_3),temp1									; in SRAM ablegen	
; FELD 19 (PEGEL)	
	ldi temp1,19
	rcall FUNKTION_GPS_DATENFELD_SUCHEN 							; INP: TEMP1(NR Datenfeld) OUT:XL+XH (START-POSITION im SRAM)	
	rcall FUNKTION_GPS_DATENFELD_BEREINIGEN_9_ZEICHEN_ASC_HEX_32 	; INP: XL+XH(ZEIGERPOSITION-SRAM) OUT:temp1...temp4  			
	STS (adr_GPS_PEGEL_3_4),temp1									; in SRAM ablegen	

ret
;###################################################################
;###################################################################
;###################################################################
; TIMER	0,1s														
TIM1_OVF:      
; Sichern				
		push temp           ; temp auf dem Stack sichern            
		in TEMP,SREG		; Einlesen des SREG 
		push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
		push temp1

;----------------------
; Timer Startwert	 
	ldi temp,HIGH(TIMERWERT)	;HIGH
	out tcnt1H,temp         
	ldi temp,LOW(TIMERWERT)   	;LOW   
	out tcnt1L,temp

;----------------------
	rcall ZEIT

;----------------------
;Zurckschreiben		
		pop temp1
		pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
		out	SREG,TEMP		; Wiederherstellen von SREG       
		pop temp      		; temp wiederherstellen                    
reti                  
;#######################################################################
;#######################################################################
;#######################################################################
ZEIT:

; 10-tel SEKUNDE	
	LDS temp,(adr_SYSTEM_ss10)	; aus SRAM_LADEN		
	inc temp					; +1	
	cpi temp,10
	brsh ZEIT_SS
	STS (adr_SYSTEM_ss10),temp	; in SRAM schreiben		
	ret
; SEKUNDE			
ZEIT_SS:
	clr temp
	STS (adr_SYSTEM_ss10),temp	; in SRAM schreiben		

	LDS temp,(adr_BETRIEBSSTUNDEN_SS)	; aus SRAM_LADEN		
	inc temp					; +1 
	cpi temp,60
	brsh ZEIT_MM
	STS (adr_BETRIEBSSTUNDEN_ss),temp	; in SRAM schreiben		
	ret
; MINUTE			
ZEIT_MM:
	clr temp
	STS (adr_BETRIEBSSTUNDEN_ss),temp			; in SRAM schreiben		
;------------------
	LDS temp,(adr_BETRIEBSSTUNDEN_SPEICHERN)	; aus SRAM_LADEN		
	inc temp	;+1
	STS(adr_BETRIEBSSTUNDEN_SPEICHERN),temp
;------------------
	LDS temp,(adr_BETRIEBSSTUNDEN_mm)	; aus SRAM_LADEN		
	inc temp					; +1 
	cpi temp,60
	brsh ZEIT_HH
	STS (adr_BETRIEBSSTUNDEN_mm),temp	; in SRAM schreiben		
	ret
; STUNDE			
ZEIT_HH:
	clr temp
	STS (adr_BETRIEBSSTUNDEN_mm),temp	; in SRAM schreiben		
	LDS temp,(adr_BETRIEBSSTUNDEN_hh)	; aus SRAM_LADEN		
	inc temp					; +1 
	STS (adr_BETRIEBSSTUNDEN_hh),temp	; in SRAM schreiben		
ret
;#######################################################################
;#######################################################################
;#######################################################################
