; ##############################################################################
; ##############################################################################
; ##############################################################################
; Initialisierung: muss ganz am Anfang des Programms aufgerufen werden
LCD_INIT:
 
           ldi temp, 0b00000011        ;muss 3mal hintereinander gesendet
           out LCD_PORT, temp          ;werden zur Initialisierung
           rcall lcd_enable            ;1
           rcall wait5ms
           rcall lcd_enable            ;2
           rcall wait5ms
           rcall lcd_enable            ;und 3!
           rcall wait5ms

           ldi temp, 0b00000010        ;4bit-Modus einstellen
		              
           out LCD_PORT, temp
           rcall lcd_enable
           rcall wait5ms

		   ldi   temp, 0b00101000      
			rcall lcd_command

           ldi temp, 0b00000001        ; DISPLAY lschen			
           rcall lcd_command
           ;ldi temp, 0b00001100        ; DISPLAY ein / CURSOR blinken
           ;rcall lcd_command
           ;ldi temp, 0b00000110        ; Cursor Auto-Increment
           ;rcall lcd_command

		   ldi   temp, 0b00001100      ; Display on, Cursor off
           rcall lcd_command
           ldi   temp, 0b00000100      ; endlich fertig


ret
;######################################################################## 
;######################################################################## 
;																		  
;erzeugt den Enable-Puls												  
;																		  
LCD_ENABLE:
           sbi LCD_PORT, LCD_E              ; Enable high		
 		   rcall wait50us                   ; kurze PAUSE		
		   cbi LCD_PORT, LCD_E              ; Enable low		
 		   rcall wait50us                   ; kurze PAUSE		
ret                          
;######################################################################## 
;######################################################################## 
;######################################################################## 
; sendet ein Datenbyte an das LCD										  
;																		  
; INPUT: temp															  
;																		  
; rcall LCD_DATA			; DATENBYTE an LCD inp: temp 				  
;																		  
LCD_DATA:
	push temp             	; "Sicherungskopie" 			
	push temp             	; "Sicherungskopie" 			
    swap temp               ; Vertauschen					
   	andi temp, 0b00001111   ; oberes Nibble auf Null setzen	
	out LCD_PORT,temp		; ausgeben						
    
	sbi LCD_PORT, LCD_RS 	; RS ein (high)					
	rcall lcd_enable        ; Enable-Routine aufrufen		
                         
    pop temp				; Kopie wieder laden	 		
   	andi temp, 0b00001111   ; oberes Nibble auf Null setzen	
	out LCD_PORT,temp		; ausgeben						
   
    sbi LCD_PORT, LCD_RS 	; RS ein  (high)	     		
	rcall lcd_enable        ; Enable-Routine aufrufen		
    pop temp				; Kopie wieder laden	 		
ret				                       
;######################################################################## 
;######################################################################## 
;######################################################################## 
;sendet einen Befehl an das LCD;wie lcd_data, nur ohne RS zu setzen		  
;																		  
; INPUT: temp															  
;																		  
LCD_COMMAND:                            
    push temp				; "Sicherungskopie" 			
    swap temp				; Vertauschen					
    andi temp, 0b00001111   ; oberes Nibble auf Null setzen	
	out LCD_PORT,temp		; ausgeben						

    cbi LCD_PORT, LCD_RS 	; RS aus (low)				
	rcall lcd_enable		; Enable-Routine aufrufen	
           
	pop temp				; Kopie wieder laden		
  	andi temp, 0b00001111   ; oberes Nibble auf Null setzen	
	out LCD_PORT,temp		; ausgeben						
           
	cbi LCD_PORT, LCD_RS 	; RS aus (low)       		
	rcall lcd_enable		; Enable-Routine aufrufen	
	rcall wait5ms			; Pause (wichtig)			
ret
;######################################################################## 
;########################################################################
;######################################################################## 
ANZEIGE_TEXT:
	lpm temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	breq ANZEIGE_TEXT_e 	; Sprung
	rcall LCD_DATA			; Anzeige
	rjmp ANZEIGE_TEXT
	ANZEIGE_TEXT_e:
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; Display lschen														  
LCD_CLEAR:
   	ldi temp, 0b00000001
    rcall lcd_command
ret
;######################################################################## 
; KURSOR GO-HOME														  
LCD_GO_HOME:
 	ldi temp, 0b00000010
	rcall lcd_command 
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; CURSOR IN ZEILE 2,3,4
LCD_ZEILE2:
 			ldi temp, 0b11000000 
			rcall lcd_command 
ret

LCD_ZEILE3:
 			ldi temp, 0b10010100 
			rcall lcd_command 
ret

LCD_ZEILE4:
 			ldi temp, 0b11010100 
			rcall lcd_command 
ret
;######################################################################## 
;########################################################################
;######################################################################## 
LCD_SPACE:
	ldi temp, ' '		; SPACE
	rcall LCD_DATA	
ret
;######################################################################## 
;########################################################################
;######################################################################## 
LCD_PUNKT:
	ldi temp, '.'		; PUNKT
	rcall LCD_DATA	
ret
;######################################################################## 
;########################################################################
;######################################################################## 
LCD_3_PUNKT:
	ldi temp, '.'		; PUNKT
	rcall LCD_DATA	
	rcall LCD_DATA	
	rcall LCD_DATA	
ret
;######################################################################## 
;########################################################################
;######################################################################## 
LCD_DOPPEL_PUNKT:
	ldi temp, ':'		; DOPPELPUNKT
	rcall LCD_DATA	
ret


; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1																	
ANZEIGE_2_STELLEN_HEX_ASC:
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_AUSGABE_ZAHL_2_STELLEN_KURZ
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1																	
ANZEIGE_3_STELLEN_HEX_ASC:
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; INPUT: TEMP1...TEMP3													  
; rcall LCD_AUSGABE_ZAHL_2_STELLEN_KURZ	; INP: TEMP1...2				  
LCD_AUSGABE_ZAHL_2_STELLEN_KURZ:
	mov temp, temp2			; 2.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rcall LCD_DATA
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; INPUT: TEMP1...TEMP3													  
; rcall LCD_AUSGABE_ZAHL_3_STELLEN_KURZ	; INP: TEMP1...3				  
LCD_AUSGABE_ZAHL_3_STELLEN_KURZ:
	mov temp, temp3			; 3.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp2			; 2.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rcall LCD_DATA
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; INPUT: TEMP1...TEMP4													  
; rcall LCD_AUSGABE_ZAHL_4_STELLEN_KURZ	; INP: TEMP1...4				  
LCD_AUSGABE_ZAHL_4_STELLEN_KURZ:
	mov temp, temp4			; 4.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp3			; 3.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp2			; 2.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rcall LCD_DATA
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; INPUT: TEMP1...TEMP5													  
; rcall LCD_AUSGABE_ZAHL_5_STELLEN_KURZ	; INP: TEMP1...5				  
LCD_AUSGABE_ZAHL_5_STELLEN_KURZ:
	
	mov temp, temp5			; 5.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp4			; 4.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp3			; 3.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp2			; 2.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rcall LCD_DATA
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; INPUT: TEMP1...TEMP6													  
; rcall LCD_AUSGABE_ZAHL_6_STELLEN_KURZ	; INP: TEMP1...6				  
LCD_AUSGABE_ZAHL_6_STELLEN_KURZ:

	rcall LCD_DATA	
	mov temp, temp4			; 4.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp3			; 3.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp2			; 2.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rcall LCD_DATA
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; INPUT: TEMP1...TEMP7													  
; rcall LCD_AUSGABE_ZAHL_7_STELLEN_KURZ	; INP: TEMP1...7				  
LCD_AUSGABE_ZAHL_7_STELLEN_KURZ:
	mov temp, temp7			; 7.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp6			; 6.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp5			; 5.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp4			; 4.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp3			; 3.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp2			; 2.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rcall LCD_DATA
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; INPUT: TEMP1...TEMP8													  
; rcall LCD_AUSGABE_ZAHL_8_STELLEN_KURZ	; INP: TEMP1...9				  
LCD_AUSGABE_ZAHL_8_STELLEN_KURZ:
	mov temp, temp8			; 8.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp7			; 7.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp6			; 6.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp5			; 5.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp4			; 4.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp3			; 3.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp2			; 2.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rcall LCD_DATA
ret

LCD_AUSGABE_ZAHL_8_STELLEN_KURZ2:
	mov temp, temp9			; 8.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp8			; 7.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp7			; 6.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp6			; 5.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp5			; 4.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp4			; 3.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp3			; 2.ZEICHEN 
	rcall LCD_DATA	
	mov temp, temp2			; 1.ZEICHEN (1-er Stelle)	
	rcall LCD_DATA
ret

LCD_FORMAT_KOORDINATE:
;   1000-er Trennzeichen einfgen	

	
	mov temp9,temp8
	mov temp8,temp7
	ldi temp7,'.'
ret

LCD_FORMAT_KOORDINATE2:
;   1000-er Trennzeichen einfgen	

	
	mov temp9,temp8
	mov temp8,temp7
	ldi temp7,'.'

LCD_FORMAT_fertig:
ret




;######################################################################## 	
;######################################################################## 	
;######################################################################## 	
; formatiert die LCD AUSGABE mit 1000-er Punkt								
; 	Bsp. "00012345 => "___12.345"											
;	INPUT/Output TEMP1														
;	INPUT/Output TEMP2														
;	INPUT/Output TEMP3														
;	INPUT/Output TEMP4														
;	INPUT/Output TEMP5														
;	INPUT/Output TEMP6														
; 	INPUT/Output TEMP8														
; 	      Output TEMP9														
LCD_FORMAT:
;   1000-er Trennzeichen einfgen	
	mov temp9,temp8
	ldi temp8,'.'
	mov temp7,temp6
	mov temp6,temp5
	mov temp5,temp4
	ldi temp4,'.'
; Nullstellen-Unterdrckung			
	cpi temp9, '0'
	brne LCD_FORMAT_fertig
	ldi temp9, '_'
	ldi temp8, '_'
	cpi temp7, '0'
	brne LCD_FORMAT_fertig
	ldi temp7, '_'
	cpi temp6, '0'
	brne LCD_FORMAT_fertig
	ldi temp6, '_'
	cpi temp5, '0'
	brne LCD_FORMAT_fertig
	ldi temp5, '_'
	ldi temp4, '_'
	cpi temp3, '0'
	brne LCD_FORMAT_fertig
	ldi temp3, '_'
	cpi temp2, '0'
	brne LCD_FORMAT_fertig
	ldi temp2, '_'
	cpi temp1, '0'
	brne LCD_FORMAT_fertig
	ldi temp1, '_'

ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; GRAD "" Programmieren 												  
LCD_SONDERZEICHEN_PROGRAMMIEREN_0:

			ldi temp, 0b01000000	; Sonderzeichen0
			rcall lcd_command 
	
			ldi temp, 0b00000111	; Zeile8 (oberste Zeile)
			rcall LCD_DATA	
			ldi temp, 0b00000101	; Zeile7
			rcall LCD_DATA	
			ldi temp, 0b00000111	; Zeile6
			rcall LCD_DATA	
			ldi temp, 0b00000000	; Zeile5
			rcall LCD_DATA	
			ldi temp, 0b00000000	; Zeile4
			rcall LCD_DATA	
			ldi temp, 0b00000000	; Zeile3
			rcall LCD_DATA	
			ldi temp, 0b00000000	; Zeile2
			rcall LCD_DATA	
			ldi temp, 0b00000000	; Zeile1 (unterste Zeile)
			rcall LCD_DATA
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; Betriebsspannung als BALKEN											  
;LCD_SONDERZEICHEN_PROGRAMMIEREN_1:
;			ldi temp, 0b01001000	; Sonderzeichen1
;			rcall lcd_command 

			; SPANNUNGSWERT laden und durch 100 teilen	
;			LDS temp1,(adr_SPANNUNG_L)
;			LDS temp2,(adr_SPANNUNG_H)
;			clr temp3
;			clr temp4
;			ldi temp5,100
;			clr temp6
;			clr temp7
;			clr temp8			
;			rcall DIVISION_32_32	; INP: Temp1...Temp4 / Temp5...Temp8 OUT: Temp1...Temp4	
;			mov temp,temp1
 ;			
;			ldi temp8, 0b00011111
;			ldi temp7, 0b00011111
;			ldi temp6, 0b00011111
;			ldi temp5, 0b00011111
;			ldi temp4, 0b00011111
;			ldi temp3, 0b00011111
;			ldi temp2, 0b00011011
;			ldi temp1, 0b00011111

;			cpi temp, 52										; Vergleich 			
;			brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_1_FERTIG 		; gleich oder grer 	
;			clr temp8											; ZEILE lschen			
			
;			cpi temp, 51
;			brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_1_FERTIG	
;			clr temp7											; ZEILE lschen			

;			cpi temp, 50
;			brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_1_FERTIG	
;			clr temp6											; ZEILE lschen			

;			cpi temp, 49
;			brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_1_FERTIG	
;			clr temp5											; ZEILE lschen			

;			cpi temp, 48
;			brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_1_FERTIG 	
;			clr temp4											; ZEILE lschen			

;			cpi temp, 47
;			brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_1_FERTIG	
;			clr temp3											; ZEILE lschen			

;			cpi temp, 46
;			brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_1_FERTIG	
;			clr temp2											; ZEILE lschen			

;			cpi temp, 45
;			brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_1_FERTIG	
;			clr temp1											; ZEILE lschen			

;LCD_SONDERZEICHEN_PROGRAMMIEREN_1_FERTIG:

;	rcall LCD_SONDERZEICHEN_PROGRAMMIEREN_ZEILEN	; INP: TEMP1...8

;ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; ANZAHL-SATELLITEN-gesamt									  			  
LCD_SONDERZEICHEN_PROGRAMMIEREN_2:

 	ldi temp, 0b01010000						; Sonderzeichen2
	rcall lcd_command 

	ldi temp8, 0b00001110
	ldi temp7, 0b00001110
	ldi temp6, 0b00001110
	ldi temp5, 0b00001110
	ldi temp4, 0b00001110
	ldi temp3, 0b00001110
	ldi temp2, 0b00001010
	ldi temp1, 0b00001110

	LDS temp,(adr_GPS_ANZ_SAT_GESAMT)				; aus SRAM laden	

	cpi temp, 8 									; vergleich			
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_2_FERTIG	; grer gleich		
	clr temp8										; ZEILE LSCHEN     
	cpi temp, 7
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_2_FERTIG
	clr temp7										; ZEILE LSCHEN     
	cpi temp, 6
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_2_FERTIG
	clr temp6										; ZEILE LSCHEN     
	cpi temp, 5
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_2_FERTIG	
	clr temp5										; ZEILE LSCHEN     
	cpi temp, 4
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_2_FERTIG 	
	clr temp4										; ZEILE LSCHEN     
	cpi temp, 3
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_2_FERTIG	
	clr temp3										; ZEILE LSCHEN     
	cpi temp, 2
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_2_FERTIG	
	clr temp2										; ZEILE LSCHEN     
	cpi temp, 1
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_2_FERTIG	
	clr temp1										; ZEILE LSCHEN     

LCD_SONDERZEICHEN_PROGRAMMIEREN_2_FERTIG:

	rcall LCD_SONDERZEICHEN_PROGRAMMIEREN_ZEILEN	; INP: TEMP1...8
		
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; ANZAHL-SATELLITEN-empfangen								  			  
LCD_SONDERZEICHEN_PROGRAMMIEREN_3:
 	ldi temp, 0b01011000	; Sonderzeichen3
	rcall lcd_command 
	
	ldi temp8, 0b00001110
	ldi temp7, 0b00001010
	ldi temp6, 0b00001110
	ldi temp5, 0b00001110
	ldi temp4, 0b00001110
	ldi temp3, 0b00001110
	ldi temp2, 0b00001010
	ldi temp1, 0b00001110

	LDS temp,(adr_GPS_ANZ_SAT_EMPFANGEN)			; aus SRAM laden	

	cpi temp, 8										; vergleich			
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_3_FERTIG 	; grer gleich		
	clr temp8										; ZEILE lschen		

	cpi temp, 7
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_3_FERTIG	
	clr temp7										; ZEILE lschen		

	cpi temp, 6
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_3_FERTIG	
	clr temp6										; ZEILE lschen		

	cpi temp, 5
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_3_FERTIG	
	clr temp5										; ZEILE lschen		

	cpi temp, 4
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_3_FERTIG 	
	clr temp4										; ZEILE lschen		

	cpi temp, 3
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_3_FERTIG	
	clr temp3										; ZEILE lschen		

	cpi temp, 2
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_3_FERTIG	
	clr temp2										; ZEILE lschen		

	cpi temp, 1
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_3_FERTIG	
	clr temp1										; ZEILE lschen		

LCD_SONDERZEICHEN_PROGRAMMIEREN_3_FERTIG:

	rcall LCD_SONDERZEICHEN_PROGRAMMIEREN_ZEILEN	; INP: TEMP1...8

ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
; /h														  			  
LCD_SONDERZEICHEN_PROGRAMMIEREN_4:
 	ldi temp, 0b01100000	; Sonderzeichen4
	rcall lcd_command 

	ldi temp8, 0b00000001
	ldi temp7, 0b00000010
	ldi temp6, 0b00000100
	ldi temp5, 0b00001000
	ldi temp4, 0b00010000
	ldi temp3, 0b00000100
	ldi temp2, 0b00000111
	ldi temp1, 0b00000101



	rcall LCD_SONDERZEICHEN_PROGRAMMIEREN_ZEILEN	; INP: TEMP1...8

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; BALKEN PEGEL 																	
LCD_SONDERZEICHEN_PROGRAMMIEREN_6:
 	ldi temp, 0b01110000	; Sonderzeichen6
	rcall lcd_command 

	ldi temp8, 0b00001110
	ldi temp7, 0b00001010
	ldi temp6, 0b00001110
	ldi temp5, 0b00001110
	ldi temp4, 0b00001110
	ldi temp3, 0b00001110
	ldi temp2, 0b00001010
	ldi temp1, 0b00001110



	; ANZAHL PEGELWERTE laden		
	LDS temp,(adr_GPS_PEGEL_ANZAHL)

	cpi temp, 8										; vergleich				
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_6_FERTIG	; gleich oder grer	
	clr temp8										; ZEILE lschen			

	cpi temp, 7
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_6_FERTIG
	clr temp7										; ZEILE lschen			

	cpi temp, 6
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_6_FERTIG
	clr temp6										; ZEILE lschen			

	cpi temp, 5
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_6_FERTIG
	clr temp5										; ZEILE lschen			

	cpi temp, 4
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_6_FERTIG
	clr temp4										; ZEILE lschen			

	cpi temp, 3
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_6_FERTIG
	clr temp3										; ZEILE lschen			

	cpi temp, 2
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_6_FERTIG
	clr temp2										; ZEILE lschen			

	cpi temp, 1
	brsh LCD_SONDERZEICHEN_PROGRAMMIEREN_6_FERTIG
	clr temp1										; ZEILE lschen			

LCD_SONDERZEICHEN_PROGRAMMIEREN_6_FERTIG:


	rcall LCD_SONDERZEICHEN_PROGRAMMIEREN_ZEILEN	; INP: TEMP1...8

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1...8																
LCD_SONDERZEICHEN_PROGRAMMIEREN_ZEILEN:
	mov temp,temp8	; Zeile8 (oberste Zeile)
	rcall LCD_DATA	
	mov temp,temp7	; Zeile7
	rcall LCD_DATA	
	mov temp,temp6	; Zeile6
	rcall LCD_DATA	
	mov temp,temp5	; Zeile5
	rcall LCD_DATA	
	mov temp,temp4	; Zeile4
	rcall LCD_DATA	
	mov temp,temp3	; Zeile3
	rcall LCD_DATA	
	mov temp,temp2	; Zeile2
	rcall LCD_DATA	
	mov temp,temp1	; Zeile1 (unterste Zeile)
	rcall LCD_DATA
ret
